## kdevelop 21.12.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# KDE Gear version, managed by release service script
set(RELEASE_SERVICE_VERSION_MAJOR "21")
set(RELEASE_SERVICE_VERSION_MINOR "12")
set(RELEASE_SERVICE_VERSION_MICRO "3")

set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

# generate patch level from release service version
set(_micro ${RELEASE_SERVICE_VERSION_MICRO})
if (_micro LESS "10")
    string(PREPEND _micro "0") # pad with 0
endif()
set(RELEASE_SERVICE_BASED_PATCHLEVEL "${RELEASE_SERVICE_VERSION_MAJOR}${RELEASE_SERVICE_VERSION_MINOR}${_micro}")

project(KDevelop VERSION "5.7.${RELEASE_SERVICE_BASED_PATCHLEVEL}")

# KDevelop SOVERSION
# E.g. for KDevelop 5.2.0 => SOVERSION 52 (we only promise ABI compatibility between patch version updates)
set(KDEVELOP_SOVERSION "${KDevelop_VERSION_MAJOR}${KDevelop_VERSION_MINOR}")

# plugin version as used e.g. in plugin installation path
# started off as 30 when 5.2 was released, incremented along the SO version so far
# TODO: perhaps switch directly to KDEVELOP_SOVERSION?
math(EXPR KDEV_PLUGIN_VERSION "30 + ${KDEVELOP_SOVERSION} - 52")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(QT_MIN_VERSION "5.15.0")
set(KF5_DEP_VERSION "5.78.0")

# we need some parts of the ECM CMake helpers
find_package (ECM ${KF5_DEP_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${KDevelop_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE) # needs to be first, as set policies influence following macros
include(ECMOptionalAddSubdirectory)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(ECMQtDeclareLoggingCategory)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(FeatureSummary)
include(WriteBasicConfigVersionFile)
include(CheckFunctionExists)
include(KDevelopMacrosInternal)


find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED Widgets Concurrent Quick QuickWidgets)
if(BUILD_TESTING)
  find_package(Qt5Test ${QT_MIN_VERSION} CONFIG REQUIRED)
endif()

find_package(KF5 ${KF5_DEP_VERSION} REQUIRED COMPONENTS
  Config
  Declarative
  DocTools
  IconThemes
  I18n
  ItemModels
  ItemViews
  JobWidgets
  KCMUtils
  KIO
  NewStuff
  NotifyConfig
  Parts
  Service
  TextEditor
  ThreadWeaver
  XmlGui
  WindowSystem
  Crash
  GuiAddons
  Archive
  Notifications
)

set(HAVE_KSYSGUARD FALSE)
find_package(KSysGuard CONFIG QUIET)
set_package_properties(KSysGuard PROPERTIES
    PURPOSE "Framework for process listing. Required for the 'Attach to Process' feature"
    TYPE RECOMMENDED
)
if(NOT KSysGuard_FOUND)
    # try old pre-Plasma 5.19 name
    find_package(KF5SysGuard CONFIG)
    set_package_properties(KF5SysGuard PROPERTIES
        PURPOSE "Framework for process listing (older name of KSysGuard). Required for the 'Attach to Process' feature"
        TYPE RECOMMENDED
    )
endif()
if(KSysGuard_FOUND OR KF5SysGuard_FOUND)
    set(HAVE_KSYSGUARD TRUE)
endif()

find_package(KDevelop-PG-Qt 1.90.90 CONFIG)
set_package_properties(KDevelop-PG-Qt PROPERTIES
    PURPOSE "KDevelop parser generator library. Required for the QMake Builder/Manager plugin."
    TYPE RECOMMENDED
)

find_package(SharedMimeInfo REQUIRED)

add_definitions(
    -DQT_DEPRECATED_WARNINGS
    -DQT_DISABLE_DEPRECATED_BEFORE=0x050900
    -DQT_DEPRECATED_WARNINGS_SINCE=0x060000
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_STRICT_ITERATORS
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
    -DKF_DISABLE_DEPRECATED_BEFORE_AND_AT=0x053200
    -DKF_DEPRECATED_WARNINGS_SINCE=0x060000
    -DQT_NO_FOREACH
)

# Turn off missing-field-initializers warning for GCC to avoid noise from false positives with empty {}
# See discussion: https://mail.kde.org/pipermail/kdevelop-devel/2014-February/046910.html
add_compile_flag_if_supported(-Wno-missing-field-initializers)
add_compile_flag_if_supported(-Werror=switch)
add_compile_flag_if_supported(-Werror=undefined-bool-conversion)
add_compile_flag_if_supported(-Werror=tautological-undefined-compare)
add_compile_flag_if_supported(-Werror=implicit-fallthrough)    # Use Q_FALLTHROUGH for false positives.
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_flag_if_supported(-Wdocumentation)
    add_compile_flag_if_supported(-Wcovered-switch-default)
    add_compile_flag_if_supported(-Wunreachable-code-break)
    # This warning is triggered by every call to qCDebug()
    add_compile_flag_if_supported(-Wno-gnu-zero-variadic-macro-arguments)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_flag_if_supported(-pedantic)
    add_compile_flag_if_supported(-Wzero-as-null-pointer-constant CXX_ONLY)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    add_compile_flag_if_supported(-Wsuggest-override CXX_ONLY)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER)
if(CMAKE_BUILD_TYPE_TOLOWER MATCHES "debug"
  OR CMAKE_BUILD_TYPE_TOLOWER STREQUAL "")
  set(COMPILER_OPTIMIZATIONS_ENABLED OFF)
else()
  set(COMPILER_OPTIMIZATIONS_ENABLED ON)
endif()

option(BUILD_BENCHMARKS "Whether benchmarks should be compiled or not" ${COMPILER_OPTIMIZATIONS_ENABLED})

# create config-kdevelop.h
configure_file(config-kdevelop.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-kdevelop.h)
include_directories(${KDevelop_BINARY_DIR}) # for config-kdevelop.h

add_subdirectory(3rdparty/timsort)

add_subdirectory(kdevplatform)
add_subdirectory(plugins)

add_subdirectory(pics)
add_subdirectory(app)
add_subdirectory(app_templates)
add_subdirectory(file_templates)
add_subdirectory(shortcuts)
add_subdirectory(doc)
add_subdirectory(share)

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KDevelop")
configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KDevelopConfig.cmake.in"
                                  "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfig.cmake"
                                  INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)
ecm_setup_version(${KDevelop_VERSION_MAJOR}.${KDevelop_VERSION_MINOR}.${KDevelop_VERSION_PATCH}
                  VARIABLE_PREFIX KDEVELOP
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdevelop_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfigVersion.cmake"
)
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/kdevelop_version.h"
        DESTINATION "${KDE_INSTALL_INCLUDEDIR}/kdevelop")
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfigVersion.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}" )
install(EXPORT KDevelopTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" NAMESPACE KDev:: FILE KDevelopTargets.cmake)

# kdebugsettings file
install_qt_logging_categories(TYPE APP_PLUGIN)

# CTestCustom.cmake has to be in the CTEST_BINARY_DIR.
# in the KDE build system, this is the same as CMAKE_BINARY_DIR.
configure_file(${CMAKE_SOURCE_DIR}/CTestCustom.cmake ${CMAKE_BINARY_DIR}/CTestCustom.cmake)

install(FILES org.kde.kdevelop.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})

# Make it possible to use the po files fetched by the fetch-translations step
ki18n_install(po)
kdoctools_install(po)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== kdevplatform/outputview/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevplatform\")

set(outputviewinterfaces_LIB_SRCS
    outputdelegate.cpp
    outputformats.cpp
    filtereditem.cpp
    ifilterstrategy.cpp
    outputmodel.cpp
    ioutputview.cpp
    ioutputviewmodel.cpp
    outputfilteringstrategies.cpp
    outputjob.cpp
    outputexecutejob.cpp
)
declare_qt_logging_category(outputviewinterfaces_LIB_SRCS
    TYPE LIBRARY
    CATEGORY_BASENAME "outputview"
)
kdevplatform_add_library(KDevPlatformOutputView SOURCES ${outputviewinterfaces_LIB_SRCS})
target_link_libraries(KDevPlatformOutputView
PUBLIC
    KF5::CoreAddons
    Qt5::Widgets
PRIVATE
    KDev::Interfaces
    KDev::Util
)

install(FILES
    ioutputview.h
    filtereditem.h
    outputmodel.h
    outputdelegate.h
    outputfilteringstrategies.h
    ioutputviewmodel.h
    ifilterstrategy.h
    outputjob.h
    outputexecutejob.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/outputview COMPONENT Devel)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== kdevplatform/serialization/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevplatform\")

set(KDevPlatformSerialization_LIB_SRCS
    abstractitemrepository.cpp
    indexedstring.cpp
    itemrepositoryregistry.cpp
    referencecounting.cpp
)

declare_qt_logging_category(KDevPlatformSerialization_LIB_SRCS
    TYPE LIBRARY
    CATEGORY_BASENAME "serialization"
)

kdevplatform_add_library(KDevPlatformSerialization SOURCES ${KDevPlatformSerialization_LIB_SRCS})
target_link_libraries(KDevPlatformSerialization
PUBLIC
    KF5::WidgetsAddons
    KF5::I18n
PRIVATE
    KDev::Util
)

install(FILES
    abstractitemrepository.h
    referencecounting.h
    indexedstring.h
    itemrepositoryexampleitem.h
    itemrepository.h
    itemrepositoryregistry.h
    repositorymanager.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/serialization COMPONENT Devel
)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== kdevplatform/template/CMakeLists.txt ===
add_subdirectory(filters)
add_subdirectory(templates)

=== kdevplatform/util/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevplatform\")

########### next target ###############

set(KDevPlatformUtil_LIB_SRCS
    autoorientedsplitter.cpp
    filesystemhelpers.cpp
    foregroundlock.cpp
    formattinghelpers.cpp
    zoomcontroller.cpp
    kdevstringhandler.cpp
    focusedtreeview.cpp
    processlinemaker.cpp
    commandexecutor.cpp
    environmentselectionwidget.cpp
    environmentselectionmodel.cpp
    environmentprofilelist.cpp
    jobstatus.cpp
    activetooltip.cpp
    executecompositejob.cpp
    shellutils.cpp
    multilevellistview.cpp
    objectlist.cpp
    placeholderitemproxymodel.cpp
    projecttestjob.cpp
    widgetcolorizer.cpp
    path.cpp
    texteditorhelpers.cpp
    stack.cpp
    expandablelineedit.cpp
)

if(NOT WIN32)
    add_subdirectory(dbus_socket_transformer)
endif()

if(BUILD_TESTING)
    add_subdirectory(duchainify) # needs KDev::Tests
endif()

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

declare_qt_logging_category(KDevPlatformUtil_LIB_SRCS
    TYPE LIBRARY
    CATEGORY_BASENAME "util"
)

kdevplatform_add_library(KDevPlatformUtil SOURCES ${KDevPlatformUtil_LIB_SRCS})
target_link_libraries(KDevPlatformUtil
PUBLIC
    KDev::Interfaces
PRIVATE
    KF5::ItemModels
    KF5::GuiAddons
)
install( FILES kdevplatform_shell_environment.sh DESTINATION bin PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)

add_executable(kdev_format_source kdevformatsource.cpp kdevformatfile.cpp)
ecm_mark_nongui_executable(kdev_format_source)
target_link_libraries(kdev_format_source Qt5::Core)
install(TARGETS kdev_format_source DESTINATION ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES .zshrc PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        DESTINATION ${KDE_INSTALL_DATAROOTDIR}/kdevplatform/shellutils/)

########### install files ###############

install( FILES
    algorithm.h
    autoorientedsplitter.h
    filesystemhelpers.h
    foregroundlock.h
    formattinghelpers.h
    zoomcontroller.h
    wildcardhelpers.h
    kdevstringhandler.h
    ksharedobject.h
    focusedtreeview.h
    activetooltip.h
    processlinemaker.h
    commandexecutor.h
    environmentselectionwidget.h
    environmentprofilelist.h
    jobstatus.h
    pushvalue.h
    kdevvarlengtharray.h
    embeddedfreetree.h
    executecompositejob.h
    convenientfreelist.h
    multilevellistview.h
    objectlist.h
    placeholderitemproxymodel.h
    projecttestjob.h
    widgetcolorizer.h
    path.h
    stack.h
    texteditorhelpers.h
    ${CMAKE_CURRENT_BINARY_DIR}/utilexport.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/util COMPONENT Devel)

=== plugins/appwizard/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevappwizard\")

########### next target ###############

set(kdevappwizard_PART_SRCS
    appwizardplugin.cpp
    appwizarddialog.cpp
    appwizardpagewidget.cpp
    projectselectionpage.cpp
    projecttemplatesmodel.cpp
    projectvcspage.cpp
)

set(kdevappwizard_PART_UI
    projectselectionpage.ui
    projectvcspage.ui
)

declare_qt_logging_category(kdevappwizard_PART_SRCS
    TYPE PLUGIN
    IDENTIFIER PLUGIN_APPWIZARD
    CATEGORY_BASENAME "appwizard"
)

ki18n_wrap_ui(kdevappwizard_PART_SRCS ${kdevappwizard_PART_UI})

if(NOT KF5_VERSION VERSION_LESS "5.57.0")
install(FILES kdevappwizard.knsrc  DESTINATION ${KDE_INSTALL_KNSRCDIR})
else()
qt5_add_resources(kdevappwizard_PART_SRCS kdevappwizardknsrc.qrc)
endif()
qt5_add_resources(kdevappwizard_PART_SRCS kdevappwizard.qrc)
kdevplatform_add_plugin(kdevappwizard SOURCES ${kdevappwizard_PART_SRCS})

target_link_libraries(kdevappwizard
    KDev::Interfaces
    KDev::Vcs
    KDev::Language
    KDev::Sublime
    KDev::Util
    KF5::KIOWidgets
    KF5::NewStuff
    KF5::Archive
)

=== plugins/clazy/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevclazy\")

find_package(ClazyStandalone QUIET)
set_package_properties(ClazyStandalone PROPERTIES
    DESCRIPTION "Qt oriented code checker based on clang framework. Krazy's little brother"
    URL "https://commits.kde.org/clazy"
    PURPOSE "Recommended: required by the non-essential Clazy plugin"
    TYPE RUNTIME
)

set(kdevclazy_core_SRCS
    checksdb.cpp
    job.cpp
    jobparameters.cpp
    utils.cpp
    checksetselection.cpp
    checksetselectionlock.cpp
    checksetselectionmanager.cpp
)
declare_qt_logging_category(kdevclazy_core_SRCS
    TYPE PLUGIN
    IDENTIFIER KDEV_CLAZY
    CATEGORY_BASENAME "clazy"
)
kconfig_add_kcfg_files(kdevclazy_core_SRCS GENERATE_MOC
    config/globalsettings.kcfgc
)
kconfig_add_kcfg_files(kdevclazy_core_SRCS
    config/projectsettings.kcfgc
)
add_library(kdevclazy_core STATIC
    ${kdevclazy_core_SRCS}
)
target_link_libraries(kdevclazy_core
    KDevCompileAnalyzerCommon
    KDev::Project
    KDev::Shell
)

set(kdevclazy_SRCS
    analyzer.cpp
    plugin.cpp

    config/customchecksetconfigproxywidget.cpp
    config/checksetselectioncombobox.cpp
    config/checksetselectionlistmodel.cpp
    config/checksetmanagewidget.cpp
    config/checkswidget.cpp
    config/commandlinewidget.cpp
    config/globalconfigpage.cpp
    config/projectconfigpage.cpp
)
ki18n_wrap_ui(kdevclazy_SRCS
    config/checksetmanagewidget.ui
    config/checkswidget.ui
    config/commandlinewidget.ui
    config/globalconfigpage.ui
    config/projectconfigpage.ui
)
qt5_add_resources(kdevclazy_SRCS
    kdevclazy.qrc
)
kdevplatform_add_plugin(kdevclazy
    SOURCES ${kdevclazy_SRCS}
)
target_link_libraries(kdevclazy
    kdevclazy_core
    KF5::ItemViews
)

ecm_install_icons(ICONS icons/128-apps-clazy.png
                  DESTINATION ${KDE_INSTALL_ICONDIR} THEME hicolor)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== plugins/documentview/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevdocumentview\")

set(kdevdocumentview_PART_SRCS
    kdevdocumentview.cpp
    kdevdocumentviewdelegate.cpp
    kdevdocumentviewplugin.cpp
    kdevdocumentmodel.cpp
    kdevdocumentselection.cpp
)

qt5_add_resources(kdevdocumentview_PART_SRCS kdevdocumentview.qrc)
kdevplatform_add_plugin(kdevdocumentview SOURCES ${kdevdocumentview_PART_SRCS})

target_link_libraries(kdevdocumentview
    KDev::Interfaces
    KDev::Util
    KF5::TextEditor
)

=== plugins/gdb/CMakeLists.txt ===
find_package(OktetaGui CONFIG)
set_package_properties(OktetaGui PROPERTIES
    PURPOSE "Required for building MemoryViewer Widget."
    URL "https://kde.org/"
    TYPE OPTIONAL)
add_definitions(-DTRANSLATION_DOMAIN=\"kdevgdb\")

set(kdevgdb_SRCS
    gdb.cpp
    gdboutputwidget.cpp
#    debuggertracingdialog.cpp
    gdbbreakpointcontroller.cpp
    debugsession.cpp
    variablecontroller.cpp
    gdbframestackmodel.cpp
    gdbvariable.cpp
)

if (OktetaGui_FOUND)
    set(KDEV_WITH_MEMVIEW true)
    list(APPEND kdevgdb_SRCS
        memviewdlg.cpp)
endif()

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/config-gdb-plugin.h.cmake
                ${CMAKE_CURRENT_BINARY_DIR}/config-gdb-plugin.h )

declare_qt_logging_category(kdevgdb_SRCS
    TYPE PLUGIN
    HEADER debuglog.h
    IDENTIFIER DEBUGGERGDB
    CATEGORY_BASENAME "gdb"
)
set(kdevgdb_UI
    debuggertracingdialog.ui
)

kde_enable_exceptions()
ki18n_wrap_ui(kdevgdb_SRCS ${kdevgdb_UI})
qt5_add_resources(kdevgdb_SRCS kdevgdb.qrc)

# common code used by plugin and unit test
add_library(kdevgdb_static STATIC ${kdevgdb_SRCS})
target_link_libraries(kdevgdb_static
    kdevdebuggercommon
    KDev::Debugger
    KDev::Shell
    KDev::Interfaces
    KDev::IExecute
    KF5::KIOWidgets
    Qt5::Core
    Qt5::Gui
)
if(OktetaGui_FOUND)
    target_link_libraries(kdevgdb_static OktetaCore OktetaGui)
endif()
set_property(TARGET kdevgdb_static PROPERTY POSITION_INDEPENDENT_CODE ON)

# The actual plugin
set(kdevgdbplugin_SRCS
    debuggerplugin.cpp
    gdbconfigpage.cpp
)
set(kdevgdbplugin_UI
    gdbconfigpage.ui
)
ki18n_wrap_ui(kdevgdbplugin_SRCS ${kdevgdbplugin_UI})
kdevplatform_add_plugin(kdevgdb SOURCES ${kdevgdbplugin_SRCS})
target_link_libraries(kdevgdb kdevgdb_static)

if(BUILD_TESTING)
    add_subdirectory(unittests)
endif()
add_subdirectory(printers)

=== plugins/ghprovider/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevghprovider\")

add_subdirectory(icons)

set(kdevghprovider_PART_SRCS
    ghlineedit.cpp
    ghprovidermodel.cpp
    ghproviderplugin.cpp
    ghproviderwidget.cpp
    ghresource.cpp
    ghaccount.cpp
    ghdialog.cpp
)
declare_qt_logging_category(kdevghprovider_PART_SRCS
    TYPE PLUGIN
    IDENTIFIER GHPROVIDER
    CATEGORY_BASENAME "ghprovider"
    DESCRIPTION "githubprovider"
)

kdevplatform_add_plugin(kdevghprovider SOURCES ${kdevghprovider_PART_SRCS})
target_link_libraries(kdevghprovider
  KF5::KIOWidgets
  KDev::Interfaces
  KDev::Vcs
  KDev::OutputView
  KDev::Util
)

=== plugins/ninjabuilder/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevninja\")
set(kdevninja_SRCS ninjajob.cpp ninjabuilder.cpp ninjabuilderpreferences.cpp)
declare_qt_logging_category(kdevninja_SRCS
    TYPE PLUGIN
    IDENTIFIER NINJABUILDER
    CATEGORY_BASENAME "ninjabuilder"
)
ki18n_wrap_ui(kdevninja_SRCS ninjaconfig.ui)
kconfig_add_kcfg_files(kdevninja_SRCS ninjabuilderconfig.kcfgc)

kdevplatform_add_plugin(kdevninja SOURCES ${kdevninja_SRCS})

target_link_libraries(kdevninja
    KDev::Interfaces
    KDev::Project
    KDev::OutputView
    KDev::Shell
    KDev::Util
)

=== plugins/standardoutputview/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevstandardoutputview\")

########### next target ###############

declare_qt_logging_category(standardoutputview_LOG_PART_SRCS
    TYPE PLUGIN
    IDENTIFIER PLUGIN_STANDARDOUTPUTVIEW
    CATEGORY_BASENAME "standardoutputview"
)

set(standardoutputview_LIB_SRCS
    standardoutputview.cpp
    outputwidget.cpp
    toolviewdata.cpp
    standardoutputviewmetadata.cpp
    ${standardoutputview_LOG_PART_SRCS}
)

kdevplatform_add_plugin(kdevstandardoutputview SOURCES  ${standardoutputview_LIB_SRCS})

target_link_libraries(kdevstandardoutputview
    KDev::Interfaces
    KDev::Sublime
    KDev::Util
    KDev::OutputView
)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== debian/changelog ===
kdevelop (4:21.12.3-0ubuntu1) jammy; urgency=medium

  * New upstream release (21.12.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Mar 2022 10:09:56 +0000

kdevelop (4:21.12.2-0ubuntu1) jammy; urgency=medium

  [ José Manuel Santamaría Lema ]
  * Update debian/watch
  * Update upstream signing key

  [ Rik Mills ]
  * New upstream release (21.12.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Feb 2022 07:16:29 +0000

kdevelop (4:21.12.1-0ubuntu1) jammy; urgency=medium

  * New upstream release (21.12.1)
  * Drop appdata-invalid-artifact.diff
  * Update lintian overrides.

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Jan 2022 10:24:21 +0000

kdevelop (4:21.12.0-0ubuntu1) jammy; urgency=medium

  * New upstream release (21.12.0)
  * Set maintainer to Kubuntu Developers.

 -- Rik Mills <rikmills@kde.org>  Thu, 09 Dec 2021 11:21:27 +0000

kdevelop (4:21.11.90-0ubuntu2) jammy; urgency=medium

  * Add Kubuntu Vcs fields.

 -- Rik Mills <rikmills@kde.org>  Sun, 28 Nov 2021 19:05:28 +0000

kdevelop (4:21.11.90-0ubuntu1) jammy; urgency=medium

  * New upstream (RC) release (21.11.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 26 Nov 2021 13:16:41 +0000

kdevelop (4:21.11.80-0ubuntu1) jammy; urgency=medium

  * New upstream (beta) release (21.11.80)
  * Drop upstream patch.
    - upstream_Fix-test_codecompletion-test_duchain-clang-test_prob.patch
  * Refresh appdata-invalid-artifact.diff
  * Rename packages according to the SONAME bumps:
    - kdevelop56-libs -> kdevelop57-libs
  * Update install files.
  * Bump KDEV_PLUGIN_VERSION to 35, according to upstream.
  * Update install files.
  * Update lintian overrides.

 -- Rik Mills <rikmills@kde.org>  Mon, 22 Nov 2021 12:46:45 +0000

kdevelop (4:5.6.2-5) unstable; urgency=medium

  * Team upload.
  * Drop the transitional kdevplatform-dev, and kdevplatform-l10n, no more
    needed after two Debian stable releases.
  * Bump Standards-Version to 4.6.0, no changes required.
  * CI: disable the blhc job.
  * Update lintian overrides.
  * Refresh patch optional-clang.diff.
  * Remove the KDevelop 5.6.0 AppImage artifact from the AppStream XML, as it
    refers to a platform that seems not supported by AppStream; patch
    appdata-invalid-artifact.diff.
  * Drop the breaks/replaces for versions older than Debian Buster.
  * Remove the explicit as-needed linking, as it is done by binutils now.

 -- Pino Toscano <pino@debian.org>  Sun, 03 Oct 2021 10:17:53 +0200

=== debian/control ===
Source: kdevelop
Section: devel
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Jeremy Lainé <jeremy.laine@m4x.org>,
           George Kiagiadakis <kiagiadakis.george@gmail.com>,
           Andreas Cord-Landwehr <cola@uni-paderborn.de>
Build-Depends: bash-completion,
               clang (>= 1:6.0) [!alpha !hppa !ia64 !kfreebsd-any !m68k !sh4 !x32],
               cmake (>= 2.8.12),
               debhelper-compat (= 13),
               dh-exec,
               extra-cmake-modules (>= 5.59.0~),
               gettext,
               kdevelop-pg-qt (>= 2.2.0),
               libastyle-dev (>= 3.1),
               libboost-serialization-dev,
               libclang-dev (>= 1:6.0) [!alpha !hppa !ia64 !kfreebsd-any !m68k !sh4 !x32],
               libgrantlee5-dev,
               libkf5archive-dev (>= 5.50.0~),
               libkf5config-dev (>= 5.50.0~),
               libkf5crash-dev (>= 5.50.0~),
               libkf5declarative-dev (>= 5.50.0~),
               libkf5doctools-dev (>= 5.50.0~),
               libkf5guiaddons-dev (>= 5.50.0~),
               libkf5i18n-dev (>= 5.50.0~),
               libkf5iconthemes-dev (>= 5.50.0~),
               libkf5itemmodels-dev (>= 5.50.0~),
               libkf5itemviews-dev (>= 5.50.0~),
               libkf5jobwidgets-dev (>= 5.50.0~),
               libkf5kcmutils-dev (>= 5.50.0~),
               libkf5kio-dev (>= 5.50.0~),
               libkf5newstuff-dev (>= 5.50.0~),
               libkf5notifications-dev (>= 5.50.0~),
               libkf5notifyconfig-dev (>= 5.50.0~),
               libkf5parts-dev (>= 5.50.0~),
               libkf5plasma-dev [linux-any],
               libkf5purpose-dev (>= 5.44.0),
               libkf5runner-dev (>= 5.72.0~) [linux-any],
               libkf5service-dev (>= 5.50.0~),
               libkf5sonnet-dev (>= 5.50.0~),
               libkf5sysguard-dev,
               libkf5texteditor-dev (>= 5.50.0~),
               libkf5threadweaver-dev (>= 5.50.0~),
               libkf5widgetsaddons-dev (>= 5.50.0~),
               libkf5windowsystem-dev (>= 5.50.0~),
               libkf5xmlgui-dev (>= 5.50.0~),
               libkomparediff2-dev (>= 4:21.12.3~),
               libqt5webkit5-dev (>= 5.7.0),
               libsvn-dev,
               llvm-dev (>= 1:6.0) [!alpha !hppa !ia64 !kfreebsd-any !m68k !sh4 !x32],
               okteta-dev (>= 5:0.26.2~),
               pkg-config,
               pkg-kde-tools (>= 0.15.16),
               qtbase5-dev (>= 5.8.0~),
               qtdeclarative5-dev (>= 5.8.0~),
               qttools5-dev,
               qttools5-dev-tools,
               shared-mime-info,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://www.kdevelop.org/
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop

Package: kdevelop57-libs
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: shared libraries for the KDevelop platform
 This package contains shared libraries needed to run integrated development
 environments based on the KDevelop platform.
 .
 This package is part of the KDevelop platform.

Package: kdevelop
Architecture: any
Depends: kdevelop-data (>= ${source:Version}),
         kdevelop57-libs (= ${binary:Version}),
         kinit,
         qml-module-qtquick-controls,
         qml-module-qtquick-layouts,
         qml-module-qtquick-window2,
         qml-module-qtquick-xmllistmodel,
         qml-module-qtquick2,
         qml-module-qtwebkit,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ${kdevelop:clang}, g++, gcc, gdb (>= 7.0), kapptemplate, kio-extras, make
Suggests: clang,
          clang-tidy,
          clazy,
          cmake,
          cppcheck,
          git,
          heaptrack [linux-any],
          kdevelop-l10n,
          konsole,
          meson,
          ninja-build
Breaks: kdevplatform10-libs (<< 5.2)
Replaces: kdevplatform10-libs (<< 5.2)
Description: integrated development environment for C/C++ and other languages
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 KDevelop has parser backends for C, C++ and Javascript/QML, with further
 external plugins supporting e.g. PHP or Python.

Package: kdevelop-data
Architecture: all
Depends: ${misc:Depends}
Breaks: kdevplatform10-libs (<< 5.2)
Replaces: kdevplatform10-libs (<< 5.2)
Description: data files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains arch independent data for KDevelop.

Package: kdevelop-dev
Section: libdevel
Architecture: any
Depends: kdevelop57-libs (= ${binary:Version}),
         libgrantlee5-dev,
         libkf5archive-dev (>= 5.50.0~),
         libkf5config-dev (>= 5.50.0~),
         libkf5guiaddons-dev (>= 5.50.0~),
         libkf5i18n-dev (>= 5.50.0~),
         libkf5iconthemes-dev (>= 5.50.0~),
         libkf5itemmodels-dev (>= 5.50.0~),
         libkf5itemviews-dev (>= 5.50.0~),
         libkf5jobwidgets-dev (>= 5.50.0~),
         libkf5kcmutils-dev (>= 5.50.0~),
         libkf5kio-dev (>= 5.50.0~),
         libkf5newstuff-dev (>= 5.50.0~),
         libkf5notifications-dev (>= 5.50.0~),
         libkf5notifyconfig-dev (>= 5.50.0~),
         libkf5parts-dev (>= 5.50.0~),
         libkf5service-dev (>= 5.50.0~),
         libkf5texteditor-dev (>= 5.50.0~),
         libkf5threadweaver-dev (>= 5.50.0~),
         libkf5windowsystem-dev (>= 5.50.0~),
         qtbase5-dev (>= 5.7.0),
         qtdeclarative5-dev (>= 5.7.0),
         ${misc:Depends},
Description: development files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains development files for KDevelop.

Package: kdevelop-l10n
Section: localization
Architecture: all
Depends: ${misc:Depends}
Description: localization files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains the translations for KDevelop.

Package: plasma-kdevelop
Architecture: linux-any
Depends: kdevelop (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: KDevelop plugins for Plasma
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains the KDevelop plugins for integrating in the Plasma
 desktop environment:
  * sessions data engine
  * sessions widget
  * sessions KRunner module

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# from the top-level CMakeLists.txt
export KDEV_PLUGIN_VERSION=35

# The list of architectures (expanded, without wildcards) that do not use clang
no_clang_args = alpha hppa ia64 kfreebsd-amd64 kfreebsd-i386 m68k sh4 x32
ifeq (,$(filter $(DEB_HOST_ARCH), $(no_clang_args)))
# The clang-N used for the build by the unversioned clang
current_clang_pkg = $(shell dpkg -S "$(shell realpath $(shell env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang))" | cut -d: -f1)
# The upstream version of a package passed as parameter
upstream_version_of_pkg = $(shell dpkg-query -f '$${Version}' -W $(1) | sed -e 's/-[^-]*$$//')
# The clang dependency string
clang_dependency = $(current_clang_pkg) (>= $(call upstream_version_of_pkg,$(current_clang_pkg))~)
else
clang_dependency =
endif

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF

execute_after_dh_auto_install:
	# create this directory if not existing, so kdevelop-data.install
	# is the same, no matter whether clang is built
	mkdir -p debian/tmp/usr/share/kdevclangsupport/
	# not useful source documentation
	rm debian/tmp/usr/share/kdevqmljssupport/propertywidgets/README

override_dh_gencontrol:
	dh_gencontrol -- -V'kdevelop:clang=$(clang_dependency)'

.PHONY: override_dh_auto_test

## kdevelop 22.08.1

=== debian/changelog ===
kdevelop (4:22.08.1-0ubuntu1) kinetic; urgency=medium

  * New upstream release (22.08.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 08 Sep 2022 07:39:22 +0100

kdevelop (4:22.08.0-0ubuntu1) kinetic; urgency=medium

  * New upstream release (22.08.0)
  * Bump KDEV_PLUGIN_VERSION to 37, according to upstream.
  * Rename packages according to the SONAME bumps:
    - kdevelop58-libs -> kdevelop59-libs

 -- Rik Mills <rikmills@kde.org>  Wed, 24 Aug 2022 11:16:45 +0100

kdevelop (4:22.04.3-0ubuntu2) kinetic; urgency=medium

  * Update lintian overrides

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Tue, 02 Aug 2022 12:34:12 +0100

kdevelop (4:22.04.3-0ubuntu1) kinetic; urgency=medium

  * New upstream release (22.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 07 Jul 2022 09:26:48 +0100

kdevelop (4:22.04.2-0ubuntu1) kinetic; urgency=medium

  * New upstream release (22.04.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 09 Jun 2022 08:00:51 +0100

kdevelop (4:22.04.1-0ubuntu1) kinetic; urgency=medium

  * New upstream release (22.04.0)
  * Rename packages according to the SONAME bumps:
    - kdevelop57-libs -> kdevelop58-libs
  * Bump KDEV_PLUGIN_VERSION to 35, according to upstream.
  * Update lintian overrides.
  * New upstream release (22.04.1)

 -- Rik Mills <rikmills@kde.org>  Wed, 11 May 2022 20:58:38 +0100

=== debian/control ===
--- 
+++ 
@@ -46,7 +46,7 @@
                libkf5widgetsaddons-dev (>= 5.50.0~),
                libkf5windowsystem-dev (>= 5.50.0~),
                libkf5xmlgui-dev (>= 5.50.0~),
-               libkomparediff2-dev (>= 4:21.12.3~),
+               libkomparediff2-dev (>= 4:22.08.1~),
                libqt5webkit5-dev (>= 5.7.0),
                libsvn-dev,
                llvm-dev (>= 1:6.0) [!alpha !hppa !ia64 !kfreebsd-any !m68k !sh4 !x32],
@@ -64,7 +64,7 @@
 Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop
 Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop
 
-Package: kdevelop57-libs
+Package: kdevelop59-libs
 Section: libs
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -77,7 +77,7 @@
 Package: kdevelop
 Architecture: any
 Depends: kdevelop-data (>= ${source:Version}),
-         kdevelop57-libs (= ${binary:Version}),
+         kdevelop59-libs (= ${binary:Version}),
          kinit,
          qml-module-qtquick-controls,
          qml-module-qtquick-layouts,
@@ -126,7 +126,7 @@
 Package: kdevelop-dev
 Section: libdevel
 Architecture: any
-Depends: kdevelop57-libs (= ${binary:Version}),
+Depends: kdevelop59-libs (= ${binary:Version}),
          libgrantlee5-dev,
          libkf5archive-dev (>= 5.50.0~),
          libkf5config-dev (>= 5.50.0~),

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 include /usr/share/dpkg/architecture.mk
 
 # from the top-level CMakeLists.txt
-export KDEV_PLUGIN_VERSION=35
+export KDEV_PLUGIN_VERSION=37
 
 # The list of architectures (expanded, without wildcards) that do not use clang
 no_clang_args = alpha hppa ia64 kfreebsd-amd64 kfreebsd-i386 m68k sh4 x32

## kdevelop 22.12.0

=== debian/changelog ===
kdevelop (4:22.12.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Thu, 22 Dec 2022 21:34:26 +0100

kdevelop (4:22.12.0-1) experimental; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.2, no changes required.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Update the build dependencies according to the upstream build system:
    - bump shared-mime-info to 1.9
  * Rename packages according to the SONAME bumps:
    - kdevelop58-libs -> kdevelop510-libs
  * Update install files.
  * Bump KDEV_PLUGIN_VERSION to 510, according to upstream.
  * Update lintian overrides.

 -- Pino Toscano <pino@debian.org>  Sat, 17 Dec 2022 16:38:50 +0100

kdevelop (4:22.04.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Fri, 27 May 2022 11:00:28 +0200

kdevelop (4:22.04.1-1) experimental; urgency=medium

  * New upstream release.
  * Update Vcs-* fields.
  * Bump Standards-Version to 4.6.1, no changes required.
  * CI: enable again the blhc job.
  * kdevelop is now part of the KDE release service, so:
    - switch watch file to release-service locations
    - import release-service GPG signing key
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.16
    - bump Qt packages to 5.15.0
    - bump KF packages to 5.78.0
  * Rename packages according to the SONAME bumps:
    - kdevelop56-libs -> kdevelop58-libs
  * Update install files.
  * Bump KDEV_PLUGIN_VERSION to 36, according to upstream.
  * Modernize building:
    - add the dh-sequence-kf5 build dependency to use the kf5 addon
      automatically, removing pkg-kde-tools
    - drop the manually specified kf5 addon for dh
  * Update lintian overrides.
  * Update the patches:
    - upstream_Fix-test_codecompletion-test_duchain-clang-test_prob.patch:
      drop, backported from upstream
    - appdata-invalid-artifact.diff: drop, fixed/removed upstream
  * Remove inactive Uploaders, adding myself as one to avoid leaving the source
    with no human maintainers.

 -- Pino Toscano <pino@debian.org>  Sun, 22 May 2022 09:43:54 +0200
